//+----------------------------------------------------------------------------------------+
//|                                                                              scoda.mq4 |
//|                                                                     |
//|                                                                        SAWR136@mail.ru |
//+----------------------------------------------------------------------------------------+
#property copyright " "
#property link      "SAWR136@mail.ru"

//+----------------------------------------------------------------------------------------+
//| expert initialization function                                                         |
//+----------------------------------------------------------------------------------------+
    extern double StopLoss   =20;                               // SL   
    extern int    Period_MA_1=7;                                //   1
    extern int    Period_MA_2=29;                               //   2
    extern double Rastvor    =6;                                //   
    extern double Lots       =0.1;                              //   . 
    extern double result_1;                                     //   
    extern double result_2;                                     //   

    string Symb;                                                //  . 
    bool  Work=true;                                            //   
//+----------------------------------------------------------------------------------------+
//| expert start function                                                                  |
//+----------------------------------------------------------------------------------------+

int start()
  {
//------------------------------------------------------------------------------------------  
       int 
       Tip=-1,                                                  //   (B=0,S=1)
       Ticket,                                                  //  
       Total;                                                   //    
       double
       MA_1_t,                                                  // . _1 
       MA_2_t,                                                  // . _2 
       result_1,                                                // .  .
       result_2;                                                // .  
   
   
       bool                                                     
       Ans  =false,                                             //     
       Opn_B=false,                                             //    BUY       
       Opn_S=false,                                             //    SELL
       Cls_B=false,                                             //    BUY
       Cls_S=false;                                             //    SELL
//------------------------------------------------------------------------------------------
    //  
    if (Work==false)                                            //  
      {
       Alert(" .  !");        
       return;                                                  //   start()
      } 
//------------------------------------------------------------------------------------------
    //  
   
            Ticket=OrderTicket();                               //  . .
            Tip   =OrderType();                                 //   .
     
      
//------------------------------------------------------------------------------------------
      //  
    MA_1_t=iMA(NULL,0,Period_MA_1,0,MODE_LWMA,PRICE_TYPICAL,-4);// _1
    MA_2_t=iMA(NULL,0,Period_MA_2,0,MODE_EMA,PRICE_TYPICAL,0);  // _2
    result_1=iAC(NULL, 0, 0);
    result_2=iAC(NULL, 0, 1);

    if ((MA_1_t<MA_2_t + Rastvor*Point) && (result_1<result_2)) //  1<2   .
        {                                                       //  
         Opn_S=true;                                            //   SELL
        }
    if ((MA_1_t>MA_2_t + Rastvor*Point) && (result_1>result_2)) //  1>2   .
        {                                                       //  
         Opn_B=true;                                            //   BUY
        }
    if (iSAR(NULL,0,0.03,0.3,0)==Point)                         //  . =
        {                                                       // 
         Cls_B=true;                                           //  
         Cls_S=true;                                           // BUY  SELL
        }      
//------------------------------------------------------------------------------------------
    //  
    while(true)
     {
       if (Tip==0 && Cls_B==true)                                //   Buy  
         {                                                       //  
          Alert("  BUY",Ticket," ..");
          RefreshRates();                                         //  
          Ans =OrderClose(Ticket,Lots,Bid,1);                      //  Buy
          if (Ans==true)                                        // 
           {
            Alert("  BUY",Ticket);
            break;                                               //    .
           }
          if (GetLastError()==1)                                 //   
              continue;                                          //              
          return;                                                //   start()   
         }
       if (Tip==1 && Cls_S==true)                                //   Buy  
         {                                                       //  
          Alert("  SELL",Ticket," ..");
          RefreshRates();                                         //  
          Ans =OrderClose(Ticket,Lots,Ask,1);                     //  Buy
          if (Ans==true)                                         // 
           {
            Alert("  SELL",Ticket);
             break;                                               //    .
           }
          if (GetLastError()==1)                                 //   
               continue;                                          //              
           return;                                                //   start()   
         }
        break;                                                    //   while
     }
//-------------------------------------------------------------------------------------------
    //  
     while(true)
      { 
       if ( Total==0 && Opn_B==true)                             //    +
         {                                                       //  . buy
          RefreshRates();                                        //  
          Alert("  Buy.  ..");
          Ticket=OrderSend(Symb,OP_BUY,Lots,Ask,1,Bid-25*Point,0,0,136,0,Blue); // Buy
          if (Ticket > 0)                                        // 
            {
              Alert ("  Buy ",Ticket);
              return;                                            //   start()
            }
          if (GetLastError()==1)                                 //  
            continue;                                            //  
            return;                                              //   start()
         }   
       if ( Total==0 && Opn_S==true)                             //    +
         {                                                       //  . sell
          RefreshRates();                                        //  
          Alert("  Sell.  ..");
          Ticket=OrderSend(Symb,OP_SELL,Lots,Bid,1,Ask-25*Point,0,0,136,0,Red); // Sell
          if (Ticket > 0)                                        // 
           {
            Alert ("  Sell ",Ticket);
            return;                                              //   start()
           }
          if (GetLastError()==1)                                 //  
            continue;                                            //  
          return;                                                //   start()
         } 
        break;                                                   //   while  
      }
//-------------------------------------------------------------------------------------------     
//----
   return(0);
  }
//+-----------------------------------------------------------------------------------------+


//+-----------------------------------------------------------------------------------------+
//| expert deinitialization function                                                        |
//+-----------------------------------------------------------------------------------------+


